/* -*- Mode: C++ -*-
 * $Id: FreeKickPositioning.h,v 1.2 2002/10/14 10:52:11 aip9 Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: FreeKickPositioning.h
 * Unitname: Framework/skill
 * $Revision: 1.2 $
 * Created by: Fredrik Heintz 2000-09-07
 * Last modified by $Author: aip9 $ $Date: 2002/10/14 10:52:11 $
 *
 *
 * HISTORY
 *
 * $Log: FreeKickPositioning.h,v $
 * Revision 1.2  2002/10/14 10:52:11  aip9
 * Update skill
 *
 * Revision 1.1  2002/09/27 15:41:03  aip9
 * Added the FreeKick and FreeKickPositioning skill
 *
 * Revision 1.5  2001/09/06 13:13:39  andbo928
 * Added class specifier to a lot of methods. Added succeed and failed methods to cc file.
 *
 * Revision 1.4  2001/09/01 14:45:12  frehe
 * Updated the skill stub to the new abstract Skill class.
 *
 * Revision 1.3  2000/09/16 18:39:39  frehe
 * Fixed the log messages.
 *
 * Revision 1.2  2000/09/16 18:36:48  frehe
 * Made minor fixes the skill stubs.
 *
 * Revision 1.1  2000/09/07 16:10:34  frehe
 * Added stubs for the skills.
 *
 */

/**
 * @file FreeKickPositioning.h
 * Include file for the skill class GotoBall.
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.2 $
 * $Author: aip9 $
 * $Date: 2002/10/14 10:52:11 $
 */


#ifndef FREEKICKPOSITIONING_H
#define FREEKICKPOSITIONING_H


#include "Skill.h"
#include "GameView.h"
#include "BallView.h"


RS_BEGIN_NAMESPACE

class GameView;
class BallView;

/**
 * @class FreeKickPositioning FreeKickPositioning.h
 * The first sentence is a brief description of the skill class FreeKickPositioning.
 * The rest is a longer description of the skill class FreeKickPositioning.
 * Use it to describe the skill!
 *
 * @pre The preconditions for the skill are ...
 * @post The intended postconditions for the skill are...
 *
 * @todo Things that should be done...
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.2 $
 * $Author: aip9 $
 * $Date: 2002/10/14 10:52:11 $
 */
class FreeKickPositioning : public Skill {
public:
	/** Default constructor. Here you can initialize the skill. */
	FreeKickPositioning();

	/** Destructor should clean up after the skill. */
	virtual ~FreeKickPositioning();

  
	/** This method is used to generate a plan for how the goal of
	the skill should be obtained by the agent. You can assume
	that the preconditions of the skill are true (this can be tested
	by calling the applicable() method, after you have implemented it). */
	virtual Plan generatePlan();

	/** This method should return a FuzzyBool telling the caller
	if the skill wants to be called again. */
	virtual FuzzyBool persistent();

	/** This method should implement the precondition specified in
	the description of the skill. */
	virtual FuzzyBool applicable();

	/** Return @c true (close to 1) if the skill has succeeded,
	i.e. its post conditions are satisfied. */
	virtual FuzzyBool succeed();

	/** Return @c true (close to 1) if the skill has failed,
	i.e. something went wrong. */
	virtual FuzzyBool failed();

  
private:
	/** Hide copy-constructor. */
	FreeKickPositioning(const FreeKickPositioning&);

	/** Hide assignment operator. */
	FreeKickPositioning& operator= (const FreeKickPositioning&);

protected:
	GameView * gameView;
	BallView * ballView;
};


RS_END_NAMESPACE


#endif // !FREEKICKPOSITIONING_H
