/* -*- Mode: C++ -*-
 * $Id: InterceptBallAip16.cc,v 1.1 2002/09/27 10:20:38 aip16 Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: InterceptBallAip16.cc
 * Unitname: Framework/skill
 * $Revision: 1.1 $
 * Created by: Quere, Kaminskas, Marchand 2002-09-13
 * 
 *
 *
 * HISTORY
 *
 *
 *
 */

#include <stdio.h>
#include "InterceptBallAip16.h"
#include "MoveToPosition.h"
#include "BallView.h"
#include "GameView.h"
#include "WorldFacts.h"
#include "view_constants.h"
#include "TurnCommand.h"
#include "DashCommand.h"
#include "MoveCommand.h"
#include "CatchBall.h"
#include "PlayerObject.h"
#include "FindBall.h"

RS_BEGIN_NAMESPACE


// --- CONSTRUCTORS ---

InterceptBallAip16::InterceptBallAip16()
  : Skill(), ballView(NULL), agentView (NULL)
{
  getView (ballView, BALL_VIEW_ID);
  getView (agentView, AGENT_VIEW_ID);
}


// --- DESTRUCTOR ---

InterceptBallAip16::~InterceptBallAip16()
{
  viewManager->releaseView(BALL_VIEW_ID);
   viewManager->releaseView(AGENT_VIEW_ID);
}


// --- METHODS ---

Plan InterceptBallAip16::generatePlan()
{
  /*
 //................V1.0 OF SKILL INTERCEPT BALL !!!................//
 

  static Command* cmd;
  Step step;
 
  PointUE balPos = ballView->getPosition(NEXT); 
  PointUE agentPos = agentView->getPosition();
  VectorUE agentToBallVector (agentPos, balPos);  
  AngleDegUE bodyPosAng = agentView->getBodyDirection();
  AngleDegUE vectorPosAng = agentToBallVector.getAngle();
  AngleDegUE turnAng (vectorPosAng - bodyPosAng);

  RS_LOG (LA_SKILL, "InterceptBallAip16: generate turn");
  
  if (abs (turnAng.getDeg()) > 15)
    {
      cmd = new TurnCommand (turnAng.getDeg());
      step.addCommand(cmd);
      delete cmd;
    }
  else
    {
      cmd = new DashCommand (50);
      step.addCommand(cmd);
      delete cmd;
    }
  return Plan(step);
}

//.................................................................//

*/


//.............OPTIMISATION: WORK IN PROGRESS!!!..................// 

 static Command* cmd;
  Step step;
 PointUE balPos1 = ballView->getPosition(NOW);
 PointUE balPos2 = ballView->getPosition(NEXT);
 VectorUE Vmoyen(balPos2, balPos1);  
PointUE balPosfinal =ballView->getPosition(NEXT)+5*0.737*Vmoyen;

PointUE agentPos = agentView->getPosition();
  VectorUE agentToBallVector (agentPos, balPosfinal);  
  AngleDegUE bodyPosAng = agentView->getBodyDirection();
  AngleDegUE vectorPosAng = agentToBallVector.getAngle();
  AngleDegUE turnAng (vectorPosAng - bodyPosAng);

  if (abs (turnAng.getDeg()) > 10)
    {
      cmd = new TurnCommand (turnAng.getDeg());
      step.addCommand(cmd);
      delete cmd;
    }
  else
    {
      cmd = new DashCommand (50);
      step.addCommand(cmd);
      delete cmd;
    }
  return Plan(step);
}

//.................................................................//

 

FuzzyBool InterceptBallAip16::persistent()
{
  // Never persistent.
  return FuzzyBool(0.0);
}


FuzzyBool InterceptBallAip16::applicable()
{
  if (!ballView->isBallKickable()) {
    RS_LOG (LA_SKILL, "Ball kickable");
    if(ballView->getPosition(NEXT).isKnown()) {
      RS_LOG (LA_SKILL, "ballpos NEXT known");
      if (agentView->getPosition().isKnown()) {
	RS_LOG (LA_SKILL, "agentpos known"); 
	if (agentView->getBodyDirection().isKnown()) {
	  RS_LOG (LA_SKILL, "agentbodydirection known");
	return FuzzyBool (1.0);
      }
     }	
    }
  }
  return FuzzyBool(0.0);
}

FuzzyBool InterceptBallAip16::succeed()
{
  // Always succedes.
  return FuzzyBool(1.0);
}

FuzzyBool InterceptBallAip16::failed()
{
  // Never fails.
  return FuzzyBool(0.0);
}

RS_END_NAMESPACE




















