/* -*- Mode: C++ -*-
 * $Id: InterceptBallAip16.h,v 1.1 2002/09/27 10:20:38 aip16 Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFIC * Filename: InterceptBallAip16.h
 * Unitname: Framework/skill
 * $Revision: 1.1 $
 * Created by: Quere, Kaminskas,Marchand 2002-09-13
 * Last modified by $Author: aip16 $ $Date: 2002/09/27 10:20:38 $
 *
 *
 * HISTORY
 *
 * 
 */


#ifndef INTERCEPTBALLAIP16_H
#define INTERCEPTBALLAIP16_H


#include "Skill.h"
#include "BallView.h"
#include "MoveToPosition.h"
#include "WorldFacts.h"
#include "TurnDirection.h"
#include "view_constants.h"
RS_BEGIN_NAMESPACE


class InterceptBallAip16 : public Skill {
public:
  /** Default constructor. Here you can initialize the skill. */
  InterceptBallAip16();

  /** Destructor should clean up after the skill. */
  virtual ~InterceptBallAip16();

  
  /** This method is used to generate a plan for how the goal of
    the skill should be obtained by the agent. You can assume
    that the preconditions of the skill are true (this can be tested
    by calling the applicable() method, after you have implemented it). */
  virtual Plan generatePlan();

  /** This method should return a FuzzyBool telling the caller
    if the skill wants to be called again. */
  virtual FuzzyBool persistent();

  /** This method should implement the precondition specified in
   the description of the skill. */
  virtual FuzzyBool applicable();

  /** Return @c true (close to 1) if the skill has succeeded,
      i.e. its post conditions are satisfied. */
  virtual FuzzyBool succeed();

  /** Return @c true (close to 1) if the skill has failed,
      i.e. something went wrong. */
  virtual FuzzyBool failed();

  
private:
  /** Hide copy-constructor. */
  InterceptBallAip16(const InterceptBallAip16&);
  /** Hide assignment operator. */
  InterceptBallAip16& operator= (const InterceptBallAip16&);
  BallView* ballView;
  AgentView* agentView;
};

RS_END_NAMESPACE

#endif // !INTERCEPTBALLAIP16_H











































