/* -*- Mode: C++ -*-
 * $Id: MathVectorUE.h,v 1.2 2002/10/14 15:15:57 aip8 Exp $Date 2002/09/27 19:00:00 aip8 $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file was created by Rosario Lombardo <roslo679@student.liu.se> and
 * is used in the framework provided by RoboSoc created by
 * Fredrik Heintz <frehe@ida.liu.se>. 
 *
 * IDENTIFICATION
 *
 * Filename: MathVector.h
 * Unitname: Framework/skill
 * $Revision: 1.2 $
 * Created by: aip8 $Date
 * Last modified by $Author: aip8 $ $Date 2002/09/27 19:00:00 $
 *
 *
 * HISTORY
 *
 * $Log: MathVectorUE.h,v $
 * Revision 1.2  2002/10/14 15:15:57  aip8
 * *** empty log message ***
 *
 * Revision 1.1  2002/09/29 22:29:24  aip8
 * MathVectorUE is used by KickToControlBall
 *
 *
 * Revision 1.0  2002/09/27 19:00:00  aip8
 * It provides the methods crossProduct, dotProduct, angleBetween
 * and norm.
 *
 * Revision 0.1  2002/09/24 00:00:00  aip8
 * It does something not well specified...
 *
 */

/**
 * @file MathVector.h
 * Interface file for the class MathVector, used in the skill KickToControlBall.
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.2 $
 * $Author: aip8 $
 * $Date: 2002/10/14 15:15:57 $
 */


#ifndef MATH_VECTOR_UE
#define MATH_VECTOR_UE


#include "CoordVectorUE.h"
RS_BEGIN_NAMESPACE


class MathVectorUE : public VectorUE
{

public:
  MathVectorUE();

  MathVectorUE(AngleDegUE, FloatUE);

  MathVectorUE(VectorUE);

  ~MathVectorUE();

  FloatUE crossProduct(VectorUE v);

  FloatUE dotProduct(VectorUE v);

  /** The result is in radians; where is AngleRadUE ?? */
  FloatUE angleBetween(VectorUE v);

  FloatUE norm();

};

RS_END_NAMESPACE

#endif //! MATH_VECTOR_UE

