/* -*- Mode: C++ -*-
 * $Id: MoveWithBallToPosition.h,v 1.2 2002/09/29 22:27:31 aip8 Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: MoveWithBallToPosition.h
 * Unitname: Framework/skill
 * $Revision: 1.2 $
 * Created by: aip8
 * Last modified by $Author: aip8 $ $Date: 2002/09/29 22:27:31 $
 *
 *
 * HISTORY
 *
 * Revision 0.0  2000/09/18 17:55:02  phigr835
 * It compiles, that's all it does.
 *
 * #include rs_log.h
 *
 */

/**
 * @file MoveWithBallToPosition.h
 * Include file for the skill class MoveWithBallToPosition.
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.2 $
 * $Author: aip8 $
 * $Date: 2002/09/29 22:27:31 $
 */


#ifndef MOVE_WITH_BALL_TO_POSITION_H
#define MOVE_WITH_BALL_TO_POSITION_H


#include "SkillWithPosition.h"
#include "WorldFacts.h"
RS_BEGIN_NAMESPACE

class BallView;
class GameView;
class AgentView;
class Worldfacts;
//class Kickkommand;
//class TurnCommand;
//class TurnNeckCommand;

/**
 * @class MoveWithBallToPosition MoveWithBallToPosition.h
 * This class encapsulates a MoveWithBallToPosition skill.
 *
 * <!--
 * @pre The preconditions are that we can excpect visual information in
 * The next cycle.
 * @post We find the ball. Or keep on turning
 *
 * @todo This needs to be done...
 * -->
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.2 $
 * $Author: aip8 $
 * $Date: 2002/09/29 22:27:31 $
 */
class MoveWithBallToPosition : public SkillWithPosition {
public:
  MoveWithBallToPosition(const Point& pos);
  virtual ~MoveWithBallToPosition();

  //void setPosition(Point p);
  void setSpeed(Float sperc);
//  virtual FuzzyBool applicable();
  virtual FuzzyBool applicable();
//  virtual Plan generatePlan();
  Plan generatePlan();

//  virtual FuzzyBool persistent();
	virtual FuzzyBool persistent(); // phg


  /** Return @c true (close to 1) if the skill has succeeded,
      i.e. its post conditions are satisfied. */
  virtual FuzzyBool succeed() { return FuzzyBool(0.5); };

  /** Return @c true (close to 1) if the skill has failed,
      i.e. something went wrong. */
  virtual FuzzyBool failed() { return FuzzyBool(0.5); };

private:
  CoordVector<Float> get0Vector(Point p);
  Float q(Float b);

protected:
  BallView* ballView;
  GameView* gameView;
  AgentView* agentView;
  /* Point position; */
  Float sperc;
	bool persist;
  const WorldFacts* facts;
	

};


RS_END_NAMESPACE


#endif // !MOVE_WITH_BALL_TO_POSITION_H
