/* -*- Mode: C++ -*-
 * $Id: MoveWithBallToPosition2.h,v 1.2 2002/10/09 16:12:52 aip8 Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: MoveWithBallToPosition2.h
 * Unitname: Framework/skill
 * $Revision: 1.2 $
 * Created by:
 * Last modified by $Author: aip8 $ $Date: 2002/10/09 16:12:52 $
 *
 *
 * HISTORY
 * Revision 0.0  2000/09/05 21:12:02  Rosario, Marinus, Philip
 *
 * #include rs_log.h
 *
 */

/**
 * @file MoveWithBallToPosition2.h
 * Include file for the skill class MoveWithBallToPosition2.
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.2 $
 * $Author: aip8 $
 * $Date: 2002/10/09 16:12:52 $
 */


#ifndef MOVE_WITH_BALL_TO_POSITION_2_H
#define MOVE_WITH_BALL_TO_POSITION_2_H

#include "SkillWithPosition.h"
#include "WorldFacts.h"
#include "GotoBall.h"

RS_BEGIN_NAMESPACE

class BallView;
class GameView;
class AgentView;
class PlayerView;

/**
 * @class MoveWithBallToPosition2 MoveWithBallToPosition2.h
 * This class encapsulates a find ball skill.
 *
 * <!--
 * @pre The preconditions are that we can excpect visual information in
 * The next cycle.
 * @post We find the ball. Or keep on turning
 *
 * @todo This needs to be done...
 * -->
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.2 $
 * $Author: aip8 $
 * $Date: 2002/10/09 16:12:52 $
 */
class MoveWithBallToPosition2 : public SkillWithPosition {
public:
  MoveWithBallToPosition2(const Point& pos);
  virtual ~MoveWithBallToPosition2();

  virtual Plan generatePlan();

  virtual FuzzyBool persistent();
  virtual FuzzyBool applicable();
  virtual FuzzyBool succeed();
  virtual FuzzyBool failed();

  //virtual void setPosition (const Point &pos);
	virtual void setSpeed(Float speed);

protected:
  const WorldFacts* worldFacts;
  BallView* ballView;
  GameView* gameView;
  AgentView* agentView;
  PlayerView* playerView;

  GotoBall gotoBallSkill;

private:
  bool planFinished;

};


RS_END_NAMESPACE


#endif // !MOVE_WITH_BALL_TO_POSITION_2_H
