/* -*- Mode: C++ -*-
 * $Id: WorldObservation.cc,v 1.2 2002/08/31 15:31:18 s02davro Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: WorldObservation.cc
 * Unitname: BasicSystem
 * $Revision: 1.2 $
 * Created by: David Rosen 2002-06-18
 * Last modified by $Author: s02davro $ $Date: 2002/08/31 15:31:18 $
 *
 *
 * HISTORY
 *
 * $Log: WorldObservation.cc,v $
 * Revision 1.2  2002/08/31 15:31:18  s02davro
 * Updated the world model
 *
 * Revision 1.1  2002/08/02 21:59:20  s02davro
 * Stores the information in a new observation made by the agent.
 *

 */

/**
 * @file WorldObservation.cc
 * Implementattion file for the class WorldObservation.
 *
 * @par Unit:
 *      BasicSystem
 * $Revision: 1.2 $
 * $Author: s02davro $
 * $Date: 2002/08/31 15:31:18 $
 */

#include "WorldObservation.h"

RS_BEGIN_NAMESPACE

WorldObservation::WorldObservation() 
  : playModes(),
    players(),
    markers(),
    lines() {
}

WorldObservation::~WorldObservation() {
}

void WorldObservation::clear() {
  playModes.clear();
  ball = ServerBallObject();
  agent = ServerAgentObject();
  players.clear();
  markers.clear();
  lines.clear();
  ownMessage = "";
  playerMessage = "";
  coachMessage = "";
  messageDirection = AngleDegUE();
  cball = CoachBallObject();
  cplayers.clear();
};
  
RS_END_NAMESPACE
