/* -*- Mode: C++ -*-
 * $Id: BasicHearStrategy.cc,v 1.4 2002/09/21 19:13:24 s02davro Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: BasicHearStrategy.cc
 * Unitname: BasicSystem
 * $Revision: 1.4 $
 * Created by: David Rosn 2002-07-01
 * Last modified by $Author: s02davro $ $Date: 2002/09/21 19:13:24 $
 *
 *
 * HISTORY
 *
 * $Log: BasicHearStrategy.cc,v $
 * Revision 1.4  2002/09/21 19:13:24  s02davro
 * Fix of playmode bug.
 *
 * Revision 1.3  2002/09/04 13:50:05  s02davro
 * *** empty log message ***
 *
 * Revision 1.2  2002/08/31 15:35:24  s02davro
 * Updated the strategies and the interface
 *
 * Revision 1.1  2002/08/02 22:00:51  s02davro
 * Created the Basic classes, needs improvements.
 *
 */

/**
 * @file BasicHearStrategy.cc
 * Implementation file for the class BasicHearStrategy.
 *
 * @par Unit:
 *      BasicSystem
 * $Revision: 1.4 $
 * $Author: s02davro $
 * $Date: 2002/09/21 19:13:24 $
 */

#include "BasicHearStrategy.h"
#include "WorldModelInterface.h"
#include "rs_error.h"

RS_BEGIN_NAMESPACE

BasicHearStrategy::BasicHearStrategy() {
}

BasicHearStrategy::~BasicHearStrategy() { 
}

void BasicHearStrategy::updateAfterHear() {
  RS_LOG ( LA_STRATEGY, "BasicHearStrategy - start");
  world = &wmi->getWorld(); 
  observation = &wmi->getObservation();

  AgentObject agent = world->getAgent();  
  agent.setSelfMessage(observation->ownMessage);
  agent.setPlayerMessage(observation->playerMessage);
  agent.setCoachMessage(observation->coachMessage);
  if (observation->messageDirection.isKnown())
    agent.setPlayerMessageDirection(observation->messageDirection);
  world->setAgent(agent);
  world->clearPlayModes();
  for (std::vector<PlayMode>::const_iterator i = observation->playModes.begin();
       i != observation->playModes.end(); ++i) {
    world->addPlayMode(*i);
  }
  RS_LOG ( LA_STRATEGY, "BasicHearStrategy - end");
}

RS_END_NAMESPACE
