/* -*- Mode: C++ -*-
 * $Id: BasicHearStrategy.h,v 1.2 2002/08/31 15:35:24 s02davro Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: BasicHearStrategy.h
 * Unitname: Framework/strategy
 * $Revision: 1.2 $
 * Created by: David Rosn 2002-07-01
 * Last modified by $Author: s02davro $ $Date: 2002/08/31 15:35:24 $
 *
 *
 * HISTORY
 *
 * $Log: BasicHearStrategy.h,v $
 * Revision 1.2  2002/08/31 15:35:24  s02davro
 * Updated the strategies and the interface
 *
 * Revision 1.1  2002/08/02 22:00:51  s02davro
 * Created the Basic classes, needs improvements.
 *
 */

/**
 * @file BasicHearStrategy.h
 * Include file for the class BasicHearStrategy.
 *
 * @par Unit:
 *      Framework/view
 * $Revision: 1.2 $
 * $Author: s02davro $
 * $Date: 2002/08/31 15:35:24 $
 */


#ifndef BASICHEARSTRATEGY_H
#define BASICHEARSTRATEGY_H

#include "basic_system_types.h"
#include "HearStrategy.h"

RS_BEGIN_NAMESPACE

/**
 * @class BasicHearStrategy BasicHearStrategy.h
 *
 * @par Unit:
 *      Framework/strategy
 * $Revision: 1.2 $
 * $Author: s02davro $
 * $Date: 2002/08/31 15:35:24 $
 */

class BasicHearStrategy : public HearStrategy {
public:
  BasicHearStrategy();
  virtual ~BasicHearStrategy();
  void updateAfterHear();
};

RS_END_NAMESPACE

#endif // !BASICHEARSTRATEGY_H
